/* 
   OpenMP "private" and "reduction" clause example

   Jim Teresco, CS 338, Williams College
   Mon Feb 24 22:30:57 EST 2003

   $Id: openmp_reduction.c,v 1.1 2003/02/25 05:37:24 terescoj Exp $
*/

#include <stdio.h>
#include <omp.h>

int main(int argc, char *argv[]) {

  int threadid = 997;
  int result;

  /* by putting threadid into the private clause, we are essentially
     creating a new copy of it for each thread */
#pragma omp parallel private(threadid) \
  reduction(+:result)
  {
    threadid = omp_get_thread_num();
    printf("In parallel directive, threadid=%d\n", threadid);
    result = 2 * threadid;
  }

  /* and when we're done, it's like we never used the original threadid */
  /* and the result has been "reduced"! */
  printf("Back from parallel directive, threadid=%d, result=%d\n", threadid,
	 result);

  return 0;
}
